<?php
/**
 * @Copyright (C) 2018, RB Consulting, Inc. All Rights Reserved
 *
 * @author Rob Broadhead
 *
 * Link Class
 */
// Class for keeping track of link information
class LinkData {
  private $id = '0';
  private $type = '';
  private $name = '';
  private $userId = '';
  private $notes = '';

  public function getId() {
    return $this -> id;
  }

  public function setId($value) {
    $this -> id = $value;
  }

  public function getName() {
    return $this -> name;
  }

  public function setName($value) {
    $this -> name = $value;
  }

  public function getNotes() {
    return $this -> notes;
  }

  public function setNotes($value) {
    $this -> notes = $value;
  }

  public function getType() {
    return $this -> type;
  }

  public function setType($value) {
    $this -> type = $value;
  }

  public function getUser() {
    return $this -> userId;
  }

  public function setUser($value) {
    $this -> userId = $value;
  }

  public function toString() {
    $retVal = $this->id . "|";
    $retVal .= $this->name . "|";
    $retVal .= $this->notes . "|";
    $retVal .= $this->userId . "|";
    $retVal .= $this->type;
    return $retVal;
    
  }

  public static function getById($id) {
    global $PDO;
    $curObj = new LinkData();

    $sql_params = array('linkId' => $id);
    $sql = "SELECT * FROM Link where linkId=:linkId";
    $row = $PDO->fetch_one($sql, $sql_params);
    if (is_array($row)) {
      $curObj->setId($row['id']);
      $curObj->setName($row['name']);
      $curObj->setType($row['typeId']);
      $curObj->setUser($row['userId']);
      $curObj->setNotes($row['notes']);
    }
    return $curObj;
  }


  public function handleEmpty($srcString) {
    if ($srcString == "") {
      $srcString = "Not Entered";
    }

    return $srcString;
  }
}
?>